package de.ozgcloud.nachrichten.postfach.osiv2;

import java.util.stream.Stream;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.client.WebClient;

import de.ozgcloud.nachrichten.postfach.PostfachNachricht;
import de.ozgcloud.nachrichten.postfach.PostfachRemoteService;

@Service
public record OsiPostfachRemoteService(
		@Qualifier("osi2PostfachWebClient") WebClient webClient
) implements PostfachRemoteService {
	public static final String POSTFACH_TYPE_OSIV2 = "OSIV2";

	@Override
	public void sendMessage(PostfachNachricht nachricht) {
		webClient.get()
				.uri("/dummy")
				.retrieve()
				.bodyToMono(String.class)
				.block();
		// TODO
	}

	@Override
	public Stream<PostfachNachricht> getAllMessages() {
		// TODO
		return Stream.empty();
	}

	@Override
	public void deleteMessage(String messageId) {
		// TODO
	}

	@Override
	public String getPostfachType() {
		return POSTFACH_TYPE_OSIV2;
	}

	@Override
	public boolean isReplyAllowed() {
		return true;
	}
}
